Subject: Re: sk_buff handling in packet handler

From: Stephen Hemminger <[email-masked]>
Date: Sun, 17 May 2009 22:38:47 -0700

On Sun, 17 May 2009 13:23:49 -0400
Claude Robitaille <[email-masked]> wrote:

> Thanks Mark.
> 
> very interesting
> 
> this helped me but just to get to next problem....
> 
> what I am trying to do is to receive frame using a packet handler, 
> manipulate it and send a portion of it over a UDP channel. I am using 
> sock_sendmsg. Things sort of work but I get some warnings while in 
> net_tx_action (via the sendmsg I am guessing) about doing scheduling 
> while in atomic and sometime the kernel simply completely crashes. All 
> this probably means that using kernel socket functions cannot be used 
> from any context.... Any suggestion on how to properly do this? 
> Ultimately, I'd like to avoid copying the data so if I could simply send 
> an skb to some UDP TX handler would be ideal but if not, what is the 
> best approach?
> 

Write a netfilter module, it is easier to do what you are trying to
do with iptables rules.

--